# Programm 7.2 zum Abstiegsverfahren (Armijo-Schrittweiten) (abstieg_gb.m)
# Min H(x,y) , H und gradH (Spaltenvektor)
#              sind als Programme (Function) bereitzustellen
# input:  Startwert (x0,y0), 
#         alpha (Daempfung des Gradienten), rho (Armijo-Parameter)
# output: Loesung (x*,y*), H(x*,y*) und grad H(x*,y*)
# Aufruf: [xs,ys,Fs,ngrad] = abstieg_gb(x0,y0,alpha,rho)
# z.B. ==> alpha = 0.5, rho = 0.1
function [xs,ys,Hs,ngrad] = abstieg_gb(x0,y0,alpha,rho);
t0 = 0.25; l = 0; k = 0; epsilon = 0.0001;
ngrad = 10;
x = x0; y = y0; t = t0;
grad = gradH(x,y); d = -alpha*grad;
fex = F(x,y);
xn = x + t*d(1);yn = y + t*d(2);
fexn = H(xn,yn);
while (ngrad > epsilon) 
   b0 = fex + t*rho*grad'*d < fexn
   while b0 && t > 0.01
       l = l+1;
       t = t*0.5; 
       xn = x + t*d(1); yn = y + t*d(2);
       fexn = H(xn,yn)
       b0 = fex + t*rho*grad'*d < fexn
   endwhile
   l = 0;
   ngrad = norm(grad); # Norm des Gradienten
   fex = fexn 
   x = x + t*d(1); y = y + t*d(2);
   grad = gradH(x,y);
   d = -alpha*grad; 
   fexn = H(x,y);
   t = t0;
   k = k+1 # Iterationszaehler
endwhile
xs = x; ys = y;
Hs = fex;
ngrad;
endfunction
