# Programm 4.1 zur Transfomation von a auf Hessenberg-Form
# input:  Matrix a=(a_{ij}) vom Typ n x n
# output: Hessenberg-Matrix h, orthogonale Matrix q^T
# Aufruf: [h,qt] = hessenberg_gb(a)
function [h,qt] = hessenberg_gb(a);
n = length(a(:,1));
# Aufbau des erweiterten Schemas [A|E]
# Endergebnis [H|Q^T]
for i=1:n
   for j=1:n
      if (i == j)
        a(i,n+j)=1;
      else
        a(i,n+j)=0;
      endif
   endfor
endfor
# Erzeugung des unteren Null-Dreiecks
for j=1:n-2
   summe=0;
   for k=j+1:n
      summe=summe+a(k,j)*a(k,j);
   endfor
   c = sign(a(j+1,j))*sqrt(summe);
   if (c ~= 0)
      a(j+1,j)=c+a(j+1,j);
      d=1/(c*a(j+1,j));
# Linksmultiplikation mit H_j
      for k=j+1:2*n
         summe=0;
         for i=j+1:n
            summe=summe+a(i,j)*a(i,k);
         endfor
         e=d*summe;
         for i=j+1:n
            a(i,k)=a(i,k)-e*a(i,j);
         endfor
      endfor
# Rechtsmultiplikation mit H_j
      for i=1:n
         summe=0;
         for k=j+1:n
            summe=summe+a(i,k)*a(k,j);
         endfor
         e=d*summe;
         for k=j+1:n
            a(i,k)=a(i,k)-e*a(k,j);
         endfor
      endfor
# update von a(j+1,j)...a(n,j)
      a(j+1,j)=-c;
      for i=j+2:n
         a(i,j)=0;
      endfor
   endif
endfor
h = a(1:n,1:n);
qt = a(1:n,n+1:n+n);
endfunction
