# Programm 8.2 (heun2rk3_gb.m)
# zur Loesung von gew. DGL 1. Ordnung y'=f(x,y), y(x_0)=y_0
# Heun-Verfahren 2. Ordnung eingebettet in ein RK-Verfahren 3. Ordnung
# input:  Start-Schrittweite h, Intervallgrenzen x0,x1, Anfangswert y0=y(x0),
#         Genauigkeit epsilon 
# output: Loesung y(x) an den Punkten x
# benutztes Programm: Nutzerfunktion f (rechte Seite der Dgl.)
# Aufruf: [y,x] = heun2rk3_gb(x0,x1,y0,h,epsilon)
function [y,x] = heun2rk3_gb(x0,x1,y0,h,epsilon);
yn = y0; y(1)=y0; k=1;
xn = x0; x(1)=x0; hs(1)=h;
while (xn+h < x1)
   k1 = f(xn,yn);
   k2 = f(xn+h,yn+h*k1);
   k3 = f(xn+0.5*h,yn+0.25*h*(k1+k2));
   yn = yn + 0.5*h*(k1+k2);
   rk = abs(h*(2*k3-k1-k2)/3);
   if (rk > epsilon)
     h = 0.5*h;
   endif
   if (rk < 0.1*epsilon)
     h = 2*h;
   endif
   xn=xn+h; x(k+1)=xn; y(k+1)=yn; hs(k+1)=h; k=k+1;
endwhile
endfunction
