# Programm 7.4 zur Jacobi-Iteration (jacobiit_gb.m)
# input:  Diagonalen l,d,u der Koeffizientenmatrix a, l(1) und u(n) sind dummy-Werte
#         rechte Seite b
# output: Loesung x
# Aufruf: [x] = jacobiit_gb(l,d,u,b)
function [x] = jacobiit_gb(l,d,u,b);
xdiff = 1; xnorm = 1; it = 0; n = length(d); x(1:n) = 0.0;
while (sqrt(xdiff/xnorm) > 10^(-10))
   xneu(1) = (b(1) - u(1)*x(2))/d(1);
   for i=2:n-1
      xneu(i) = (b(i) - l(i)*x(i-1) - u(i)*x(i+1))/d(i);
   endfor
   xneu(n) = (b(n) - l(n)*x(n-1))/d(n);
   xdiff = 0; xnorm = 0;
   for i=1:n
      xdiff = xdiff + (xneu(i)-x(i))^2;
      x(i) = xneu(i);
      xnorm = xnorm + x(i)^2; 
   endfor
   if (xnorm == 0)
      xnorm = 1;
   endif
   it = it + 1;
endwhile
it
endfunction
