# Programm 3.1 zur QR-Zerlegung einer Matrix c0 = q*r
# Erzeugung der wesentlichen Informationen fuer 
# die orthogonale Matrix Q und der oberen Dreiecksmatrix R
# input:  Matrix c0=(c0(ij)) vom Typ m x p gegeben (m >= p)
# output: Matrix c mit den wesentlichen Informationen
#         der orthogonalen Matrix q und der oberen Dreiecksmatrix r,
#         Vektor t mit den ersten Nichtnull-Komponenten von q1,q2,...
#         Erzeugung des inputs fuer das Programm bestapprqr_gb.m,
# Aufruf: [c,t] = qr_gb(c0);
function [c,t] = qr_gb(c0);
c=c0;
m = length(c(:,1));
p = length(c(1,:));
for l=1:p
  gamma=0;
  for i=l:m
    gamma = gamma + c(i,l)*c(i,l);
  endfor
  gamma = sqrt(gamma);
  if (c(l,l) < 0)
    gamma = -gamma;
  endif
  peta=sqrt(2*gamma*(gamma+c(l,l)));
  t(l) = -gamma;
  c(l,l) = (c(l,l)+gamma)/peta;
  for k=l+1:m
    c(k,l) = c(k,l)/peta;
  endfor
  for j=l+1:p
    g=0;
    for k=l:m
      g = g + c(k,l)*c(k,j);
    endfor
    g = g + g;
    for i=l:m
      c(i,j) = c(i,j) - g*c(i,l);
    endfor
  endfor
endfor
endfunction
