# Programm 4.2 Ein Schritt H^k,P^k --> H^{k+1},P^{k+1} zum QR-Verfahren 
# sukzessive Berechnung der Eigenwerte einer (n x n)-Hessenberg-Matrix H
# H^k,P^k Shift kappa und delta (kleinste Zahl >0) sind vorgegeben
# input:  h0=H^k, p0=P^k, Shift kappa und delta (kleinste Zahl >0)
# output: h=H^{k+1}, p=P^{k+1}
# Aufruf: [h,p] = qriteration_gb(h0,p0,kappa,delta);
function [h,p] = qriteration_gb(h0,p0,kappa,delta);
h = h0; p =p0;
n = length(h(:,1));
h(1,1)=h(1,1)-kappa;
for i=1:n
   if (i < n)
      if (abs(h(i,i)) < delta*abs(h(i+1,i)))
         w=abs(h(i+1,i));
	 c=0;
	 s=sign(h(i+1,i));
      else
         w=sqrt(h(i,i)^2 + h(i+1,i)^2);
	 c=h(i,i)/w;
	 s=-h(i+1,i)/w;
      endif
      h(i,i)=w;
      h(i+1,i)=0;
      h(i+1,i+1)=h(i+1,i+1)-kappa;
      for j=i+1:n
         g=c*h(i,j)-s*h(i+1,j);
	 h(i+1,j)=s*h(i,j)+c*h(i+1,j);
	 h(i,j)=g;
      endfor
   endif
   if (i > 1)
      for j=1:i
         g=cs*h(j,i-1)-ss*h(j,i);
	 h(j,i)=ss*h(j,i-1)+cs*h(j,i);
	 h(j,i-1)=g;
      endfor
      h(i-1,i-1)=h(i-1,i-1)+kappa;
   endif
   if (i < n)
     for j=1:n
        g=c*p(j,i)-s*p(j,i+1);
        p(j,i+1)=s*p(j,i)+c*p(j,i+1);
	p(j,i)=g;
     endfor
   endif
   cs = c;
   ss = s;
endfor
h(n,n)=h(n,n)+kappa;
endfunction
