# Programm 8.3 (ruku4sys_gb.m)
# zur Loesung eines Systems von 3 DGL 1. Ordnung y_j'=g_j(x,y), y_(x_0)=y_0j
# klassisches Runge-Kutta-Verfahren 4. Ordnung
# input:  Schrittweite h, Intervallgrenzen x0,x1, Anfangswerte y0j=y_j(x0),
# output: Loesung y1(x),y2(x),y3(x) an den Punkten x
# benutztes Programm: Nutzerfunktion g (rechte Seite der Dgl.)
# Aufruf: [y1,y2,y3,x] = ruku4sys_gb(x0,x1,y01,y02,y03,h);
function [y1,y2,y3,x] = ruku4sys_gb(x0,x1,y01,y02,y03,h);
n = (x1 - x0)/h;
yn1 = y01; yn2 = y02; yn3 = y03; 
y1(1)=y01; y2(1)=y02; y3(1)=y03;
xn = x0; x(1)=x0; 
for k=1:n
   k11 = g(1,xn,yn1,yn2,yn3);
   k12 = g(2,xn,yn1,yn2,yn3);
   k13 = g(3,xn,yn1,yn2,yn3);
   k21 = g(1,xn+0.5*h,yn1+0.5*h*k11,yn2+0.5*h*k12,yn3+0.5*h*k13);
   k22 = g(2,xn+0.5*h,yn1+0.5*h*k11,yn2+0.5*h*k12,yn3+0.5*h*k13);
   k23 = g(3,xn+0.5*h,yn1+0.5*h*k11,yn2+0.5*h*k12,yn3+0.5*h*k13);
   k31 = g(1,xn+0.5*h,yn1+0.5*h*k21,yn2+0.5*h*k22,yn3+0.5*h*k23);
   k32 = g(2,xn+0.5*h,yn1+0.5*h*k21,yn2+0.5*h*k22,yn3+0.5*h*k23);
   k33 = g(3,xn+0.5*h,yn1+0.5*h*k21,yn2+0.5*h*k22,yn3+0.5*h*k23);
   k41 = g(1,xn+h,yn1+h*k31,yn2+h*k32,yn3+h*k33);
   k42 = g(2,xn+h,yn1+h*k31,yn2+h*k32,yn3+h*k33);
   k43 = g(3,xn+h,yn1+h*k31,yn2+h*k32,yn3+h*k33);
   yn1 = yn1 + h*(k11+2.0*k21+2.0*k31+k41)/6.0;
   yn2 = yn2 + h*(k12+2.0*k22+2.0*k32+k42)/6.0;
   yn3 = yn3 + h*(k13+2.0*k23+2.0*k33+k43)/6.0;
   xn = xn+h; x(k+1)=xn; y1(k+1)=yn1; y2(k+1)=yn2; y3(k+1)=yn3;
endfor
endfunction
