# Programm 8.5 Schiessverfahren zur Loesung eines 2-Punkt-RWP (schiessv_gb.m)
#  y''=fs(x,y), y(a)=eta0, y(b)=eta1
# input:  Intervallgrenzen a,b, n Anzahl der Teilintervalle, eta0,eta1
#         zeta als Startwert des Newton-Verfahrens fuer y'(a)
# output: Loesung y1(x) an den Stellen x
# benutzte Programme: fs1,fs2,fsy2 fuer die rechten Seiten der AWP's
#         rungek4fs(x,y01,y11,h,n),rungek4fsy(x,y1,y2,y02,y12,h,n)
#         zur Implementierung des klassischen RK-Verfahrens 4.Ordn.
# Aufruf: [y1,x] = schiessv_gb(a,b,eta0,eta1,n,zeta);
function [y1,x] = schiessv_gb(a,b,eta0,eta1,n,zeta);
h=(b-a)/n;
for i=1:n+1
  x(i)=a+(i-1)*h;
endfor
it=0; g=1; y02=0; y12=1; y01=eta0;
while (abs(g) > 10^(-6) && it < 10)
  y11=zeta;
  [y1,y2] = rungek4fs(x,y01,y11,h,n);
  g = y1(n+1)-eta1
#
  [yy1,yy2] = rungek4fsy(x,y1,y02,y12,h,n);
  gy = yy1(n+1);
  zeta = zeta - g/gy
  it = it+1;
endwhile
endfunction
