# Programm 10.4 stoch_int_gb1.m : Ito- und Stratonowitsch-Integral
#              /                                / 
# Ito Integral | W dW , Stratonowitsch Integral | W o dW
#              /                                /
randn('state',400) # random seeding
T = 1 ; N = 5000 ; dt = T/N;
dW = zeros(1,N); W = zeros(1,N); ito = zeros(1,N-1); 
Xito = zeros(1,N); strat = zeros(1,N); # Pre-Allokierung
dW = sqrt(dt)*randn(1,N) ; # Inkremente des Wiener-Prozess W
W = cumsum(dW) ; # kumulative Summe
for j = 1:N-1
    tito = 0;
    for i = 1:j
       tito = tito + W(i)*dW(i+1);
    endfor
    ito(j) = tito;
# sum([0,W(1:j)].*dW(1:j+1)) ;
endfor 
Xito = [0,ito] ; strat(1) = 0.5*W(1)*dW(1) ;
for j=2:N
    strat(j) = sum( (0.5*([0,W(1:j-1)]+W(1:j)) ).*dW(1:j)) ;
endfor
plot([dt:dt:T],W,'r-'), hold on
xlabel('t','FontSize',16);
plot([dt:dt:T],Xito,'b--'), hold off
figure(2);
plot([dt:dt:T],W,'r-'), hold on
xlabel('t','FontSize',16);
plot([dt:dt:T],strat,'g--'), hold off
figure(3);
plot([dt:dt:T],Xito,'b--'), hold on
xlabel('t','FontSize',16);
plot([dt:dt:T],strat,'g--'), hold off
itoerr = abs(Xito(N) - 0.5*(W(end)^2-T))
straterr = abs(strat(N) - 0.5*W(end)^2)
# Programmende
